{{
      $Id: Arduino[Math].spin 6 2011-11-28 06:27:01Z pedward $
   Object: Arduino::Math
  Version: 1.0
   Author: Perry Harrington
Copyright: (c) 2011 Perry Harrington
=======================================================================

This object is a SPIN interface to emulate the Arduino SDK functions
for simple math functions.

}}

PUB _min(x,y)
  if x > y
    return y
  return x

PUB _max(x,y)
  if x > y
    return x
  return y

PUB _abs(x)
  return || x

PUB constrain(x,a,b)
  return x #> a <# b

PUB map(val,fromL,fromH,toL,toH)
  return (val - fromL) * (toH - toL) / (fromH - fromL) + toL

PUB pow(base, exp)
  result:=base
  repeat exp-1
    result*=base

PUB sqrt(x)
  return ^^x

PUB rad2deg(rad)


PUB sin(degree, range) : s | c,z,angle
  angle := (degree*91)~>2  ' *22.75
  c := angle & $800
  z := angle & $1000
  if c
    angle := -angle
  angle |= $E000>>1
  angle <<= 1
  s := word[angle]
  if z
    s := -s
  return (s*range)~>16     ' return sin = -range..+range

PUB cos(degree,range)
  return sin(degree+90,range)

PUB tan(degree,range)
  result := sin(degree,range)
  result *= range
  result /= cos(degree,range)

